import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.io.*;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.Image;
import java.util.Arrays;
import java.util.Properties;
import javax.swing.event.TableModelEvent;
import java.text.SimpleDateFormat;
import java.text.DateFormat;
import java.util.Date;

// MD5
import java.io.*;
import java.security.MessageDigest;
import java.math.BigInteger;

// TABLE_COL_EDITORS
import javax.swing.AbstractCellEditor;
import javax.swing.table.TableCellEditor;
import javax.swing.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class NextMP3Player extends JFrame
{
	public String previousFileName;
	public String currentFileName;
	public String currentLastPlay;
	public String currentPlays;
	public String currentTags;
	public String currentInfo;
	public String tempDir = "C:\\WINDOWS\\TEMP";

	// todo: add support for external filename changing by using the MD5 hash

	/********************************
	USE OF PROPS.LOAD CAUSED BEHAVIOUR:
	JAR FILE WOULD LOAD FINE WHEN CLICKED,
	BUT WOULD NOT LOAD WHEN CALLED BY A SHORTCUT!!!!!
	OTHER JAR FILES FINE WHEN CALLED BY SHORTCUT TO JAVAW.EXE -JAR

	SO MUST EDIT PROPERTIES HERE IN THE JAVA FILE IF NECESSARY
	********************************/
	//Properties props = new Properties();
	//try{props.load(new FileInputStream(defaultIniFileName));
	//}catch (IOException e){System.err.println("Error1: " + e.getMessage());}

	String	directoryPath	= "C:/";//props.getProperty("directoryPath");
	String	mp3_player		= "C:/Progra~1/Window~1/mplayer2";//props.getProperty("mp3_player");
	String	mp32_player		= "C:/Program Files/Winamp/winamp.exe";//props.getProperty("mp32_player");
	String	missOut			= "stuff";//props.getProperty("missOut");
	String	requiredString	= ".mp3";//props.getProperty("requiredString");
	int		widthOfScrollBar= 26;//Integer.valueOf(props.getProperty("widthOfScrollBar")).intValue();

	public int currentRow;
	public JTable table;
	String dataFileName = "-z-.dat";
	String defaultIniFileName = "nextmp3.ini";


	public static void main(String[] args)
	{
		String passString = "";
		try
		{
			passString = args[0];
		}
		catch (ArrayIndexOutOfBoundsException e)
		{
			// no problem
		}

		final NextMP3Player frame = new NextMP3Player(passString);
		frame.addWindowListener
		(
			new WindowAdapter()
			{
				public void windowClosing( WindowEvent e )
				{
					System.exit(0);
				}
			}
		);
	}


	public NextMP3Player(String param)
	{
		super("NextMP3 Player - double click to edit");

		this.setVisible(false);

		//byte[] myArrayImage =
		// use Create Image Byte Array software
		//Image myimage = Toolkit.getDefaultToolkit().createImage(myArrayImage);
		//this.setIconImage(myimage);

		Dimension scr = Toolkit.getDefaultToolkit().getScreenSize();
		int width = scr.width;
		int height= scr.height-200;
		this.setBounds( (scr.width-width)/2 , (scr.height-height)/2 , width , height);
		this.setDefaultCloseOperation(this.EXIT_ON_CLOSE);

		String temp = populateTable();

		if (!param.equals("noplay"))
		{
			chooseFileToPlay();
		}

		this.setVisible(true);

		if (!param.equals("noplay"))
		{
			this.setState(JFrame.ICONIFIED); // minimized. do after setvisible or it goes weird
		}

		//table.editCellAt(currentRow,4);
	}




	private void chooseFileToPlay()
	{
		int lastFileNumberPlays = 1;
		for (int row=0;row<table.getRowCount();row++) // cycle through table
		{
			String numberPlaysStr = (String)table.getModel().getValueAt(row, 2);
			if (numberPlaysStr == null){numberPlaysStr = "0";}
			if (numberPlaysStr.equals("")){numberPlaysStr = "0";}
			int numberPlays = Integer.parseInt(numberPlaysStr);

			if (numberPlays < lastFileNumberPlays)
			{
				numberPlays++;
				numberPlaysStr = Integer.toString(numberPlays);

				SimpleDateFormat sdf = new SimpleDateFormat("dd MMM yyyy");
	            String parsed = sdf.format(new Date());

				currentRow = row;
				currentFileName = (String)table.getModel().getValueAt(currentRow, 0);
				currentLastPlay = parsed.toString();
				currentPlays = numberPlaysStr;
				currentTags = (String)table.getModel().getValueAt(currentRow, 3);
				currentInfo = (String)table.getModel().getValueAt(currentRow, 4);
				updateDatabase();


				ListSelectionModel selectionModel = table.getSelectionModel();
				selectionModel.setSelectionInterval(row, row);


				Process p = null;
				Runtime r = Runtime.getRuntime();
				String OS = System.getProperty("os.name").toLowerCase();
				if (OS.indexOf("windows") > -1 ||
					OS.indexOf("nt") > -1)
				{
					try
					{
						// RUN REGEDIT TO SET WMP VOLUME
						String regFileName = tempDir+"/"+"wmp_unmute.reg";
						File tempFile = new File(regFileName);
					    FileWriter fw = new FileWriter(tempFile);
				       	BufferedWriter bw = new BufferedWriter(fw);
						bw.write("REGEDIT4\n\n[HKEY_CURRENT_USER\\Software\\Microsoft\\MediaPlayer\\Player\\Settings]\n\"View\"=\"1\"\n\"Volume\"=\"0\"\n\"PlayCount\"=\"0\"\n\"Mute\"=\"no\"\n\n[HKEY_USERS\\.DEFAULT\\Software\\Microsoft\\MediaPlayer\\Player\\Settings]\n\"View\"=\"1\"\n\"Volume\"=\"0\"\n\"PlayCount\"=\"0\"\n\"Mute\"=\"no\"\n");
						bw.close();
						p = r.exec( "regedit -s \""+regFileName+"\"" );

						// RUN MP3 PLAYER
						if (currentFileName.endsWith(".mp3"))
						{
							p = r.exec( mp3_player+" \""+directoryPath+"/"+currentFileName+"\"" );
						}
						else if (currentFileName.endsWith(".mp32"))
						{
							p = r.exec( mp32_player+" \""+directoryPath+"/"+currentFileName+"\"" );
						}
					}
					catch (IOException e)
					{
						e.printStackTrace(System.err);
					}
				}

				return;
			}
			else
			{
				lastFileNumberPlays = numberPlays;
			}
		}
	}




	private String populateTable()
	{
		File dir = new File(directoryPath); // directoryPath no end slash
		String[] filesInDir = dir.list();
		Arrays.sort(filesInDir);
		int numberFiles = 0;
		if (filesInDir == null)
		{
			return "Input does not exist or is not a directory";
		}
		else
		{
			for (int i=0; i<filesInDir.length; i++)
			{
				if (filesInDir[i].toLowerCase().indexOf(missOut) < 0
				&& filesInDir[i].indexOf(requiredString) > 0)
				{
					String fileName = filesInDir[i];
					numberFiles++;
				}
			}
		}

		table = new JTable(numberFiles,5);


		// populate
		numberFiles = 0;
		for (int i=0; i<filesInDir.length; i++)
		{
			if (filesInDir[i].toLowerCase().indexOf(missOut) < 0
			&& filesInDir[i].indexOf(requiredString) > 0)
			{
				String fileName = filesInDir[i];
				numberFiles++;
				table.setValueAt(fileName, numberFiles-1, 0);
			}
		}


		// set columns

		// Disable auto resizing
		table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

		// Set the first visible column to 100 pixels wide
		int widthSoFar = 0;
		TableColumn col = table.getColumnModel().getColumn(0);
		col.setHeaderValue("File");
  		col.setPreferredWidth(300);
  		col.setCellEditor(new Table_Col_1_Editor(this));
  		widthSoFar += col.getPreferredWidth();

		col = table.getColumnModel().getColumn(1);
		col.setHeaderValue("Lastplay");
		col.setPreferredWidth(50);
		col.setCellEditor(new Table_Col_2_3_Editor(this));
		widthSoFar += col.getPreferredWidth();

		col = table.getColumnModel().getColumn(2);
		col.setHeaderValue("#Plays");
		col.setPreferredWidth(40);
		col.setCellEditor(new Table_Col_2_3_Editor(this));
		widthSoFar += col.getPreferredWidth();

		col = table.getColumnModel().getColumn(3);
		col.setHeaderValue("Tags");
		col.setPreferredWidth(30);
		col.setCellEditor(new Table_Col_4_Editor(this));
		widthSoFar += col.getPreferredWidth();

		col = table.getColumnModel().getColumn(4);
		col.setHeaderValue("Info");
		col.setPreferredWidth(this.getWidth()-widthOfScrollBar-widthSoFar);
		col.setCellEditor(new Table_Col_5_Editor(this));

		JScrollPane scrollTable = new JScrollPane( table );
		scrollTable.setColumnHeader(null);
		scrollTable.setMinimumSize(new Dimension(this.getWidth(),80));

		Container c = getContentPane();
		c.add(scrollTable);

		updateTableFromDatabase();

		return "";


	}



	public void updateDatabase()
	{
		// update details about the current file

		File tempFile = null;
		File dataFile = null;
		BufferedWriter bw = null;
		BufferedReader br = null;
		try
		{
			tempFile = new File(directoryPath+"/"+dataFileName+".tmp");
			dataFile = new File(directoryPath+"/"+dataFileName);

		    FileWriter fw = new FileWriter(tempFile);
        	bw = new BufferedWriter(fw);
		}
		catch (IOException e)
		{
			//Catch exception if any
			System.err.println("Error8: ");
			e.printStackTrace(System.err);
		}

		String strLine;
		try
		{
            br = new BufferedReader(new FileReader(dataFile));

            //if (!br.ready()) throw new IOException();

			//Read File Line By Line
			String[] fields;
            while ((strLine = br.readLine()) != null)
            {
				if (strLine.length() > 2)
				{
					fields = strLine.split("\t");
					String databaseFileName	= fields[0];
					String databaseMD5		= fields[1];
					String databaseLastPlay	= fields[2];
					String databasePlays	= fields[3];
					String databaseTags		= fields[4];
					String databaseInfo		= fields[5];

					if (!databaseFileName.equals(previousFileName))
					{
						// write the line straight to the temp file
						bw.write(strLine+"\n");
					}
					else
					{
						//System.out.println("222");
					}
				}
			}
			br.close();
		}
		catch (FileNotFoundException e)
		{
			//1st time writing to the file. that's ok.
		}
		catch (IOException e)
		{
			System.err.println("Error9: ");
		}

		try
		{
			// now write the new data
			String currentMD5 = MD5.get(new File(directoryPath+"/"+currentFileName));

			strLine = currentFileName
					+"\t"
					+currentMD5
					+"\t"
					+currentLastPlay
					+"\t"
					+currentPlays
					+"\t"
					+currentTags
					+"\t"
					+currentInfo
					+"\t|\n";

			bw.write(strLine);

			bw.close();

			dataFile.delete();
			tempFile.renameTo(dataFile);

			// set user file hidden
			// system execute snippet inspired by http://www.rgagnon.com/javadetails/java-0150.html
			// unix files are hidden by starting them with ".", so there's an element of portability

			/* commented out since it was causing a DOS box to come up
			Process p = null;
			Runtime r = Runtime.getRuntime();
			String OS = System.getProperty("os.name").toLowerCase();
			if (OS.indexOf("windows") > -1 ||
				OS.indexOf("nt") > -1)
			{
				String command = "attrib +H " + "\""+directoryPath.replace('/','\\')+"\\"+dataFileName+"\"";
				p = r.exec(command);
			}
			*/
		}
		catch (IOException e)
		{
			System.err.println("Error5: ");
			e.printStackTrace(System.err);
		}
	}



	public void updateTableFromDatabase()
	{
		File dataFile = null;
		BufferedReader br = null;

		dataFile = new File(directoryPath+"/"+dataFileName);

		String strLine;
		try
		{
            br = new BufferedReader(new FileReader(dataFile));

            //if (!br.ready()) throw new IOException();

			//Read File Line By Line
			String[] fields;
            while ((strLine = br.readLine()) != null)
            {
				if (strLine.length() > 2)
				{
					fields = strLine.split("\t");
					String databaseFileName	= fields[0];
					String databaseMD5		= fields[1];
					String databaseLastPlay	= fields[2];
					String databasePlays	= fields[3];
					String databaseTags		= fields[4];
					String databaseInfo		= fields[5];

					if (databaseFileName.equals("null")){databaseFileName = "";}
					if (databaseMD5.equals("null")){databaseMD5 = "";}
					if (databaseLastPlay.equals("null")){databaseLastPlay = "";}
					if (databasePlays.equals("null")){databasePlays = "";}
					if (databaseTags.equals("null")){databaseTags = "";}
					if (databaseInfo.equals("null")){databaseInfo = "";}

					for (int row=0;row<table.getRowCount();row++) // cycle through table
					{
						String rowFilename = (String)table.getModel().getValueAt(row, 0);
						if (databaseFileName.equals(rowFilename))
						{
							table.setValueAt(databaseLastPlay,	row, 1);
							table.setValueAt(databasePlays,		row, 2);
							table.setValueAt(databaseTags,		row, 3);
							table.setValueAt(databaseInfo,		row, 4);
						}
					}
				}
			}
			br.close();
		}
		catch (FileNotFoundException e)
		{
			//there is no file. that's ok.
		}
		catch (IOException e)
		{
			System.err.println("Error10: ");
		}
	}

}




class Table_Col_1_Editor extends AbstractCellEditor implements TableCellEditor
{
	NextMP3Player parent;
	String prevFileName;

	Table_Col_1_Editor(NextMP3Player p)
	{
		parent = p;
	}
	// This is the component that will handle the editing of the cell value
	JComponent component = new JTextField();


    public boolean isCellEditable(EventObject anEvent) {
        MouseEvent me = (MouseEvent) anEvent;
        try{if (me.getClickCount() == 2) return true;}
		catch (NullPointerException e){/*was throwing this after the other problem like this in cols 4+5. when pressed spacebar?*/}
		return false;
    }


	// This method is called when a cell value is edited by the user.
	public Component getTableCellEditorComponent(JTable table, Object value,
			boolean isSelected, int rowIndex, int vColIndex)
	{
		// 'value' is value contained in the cell located at (rowIndex, vColIndex)

		parent.currentRow = rowIndex;

		if (isSelected)
		{
			// cell (and perhaps other cells) are selected
		}

		// Configure the component with the specified value
		((JTextField)component).setText((String)value);

		prevFileName = ((JTextField)component).getText();

		// Return the configured component
		return component;
	}

	// This method is called when editing is completed.
	// It must return the new value to be stored in the cell.
	public Object getCellEditorValue()
	{
		String newVal = ((JTextField)component).getText();

		if (!newVal.equals(prevFileName))
		{
			File file  = new File(parent.directoryPath+"/"+prevFileName);
			File file2 = new File(parent.directoryPath+"/"+newVal);

			// Rename file (or directory)
			boolean success = file.renameTo(file2);
			if (success)
			{
				parent.previousFileName = prevFileName;
				parent.currentFileName = newVal;

				parent.currentLastPlay = (String)parent.table.getModel().getValueAt(parent.currentRow, 1);
				parent.currentPlays = (String)parent.table.getModel().getValueAt(parent.currentRow, 2);
				parent.currentTags = (String)parent.table.getModel().getValueAt(parent.currentRow, 3);
				parent.currentInfo = (String)parent.table.getModel().getValueAt(parent.currentRow, 4);


				parent.updateDatabase();
			}
		}

		return ((JTextField)component).getText();
	}
}



class Table_Col_2_3_Editor extends AbstractCellEditor implements TableCellEditor
{
	NextMP3Player parent;
	String prevFileName;

	Table_Col_2_3_Editor(NextMP3Player p)
	{
		parent = p;
	}
	// This is the component that will handle the editing of the cell value
	JTextField component = new JTextField();

    public boolean isCellEditable(EventObject anEvent) {
        return false;
    }

	// This method is called when a cell value is edited by the user.
	public Component getTableCellEditorComponent(JTable table, Object value,
			boolean isSelected, int rowIndex, int vColIndex)
	{
		component.setEditable(false);

		prevFileName = ((JTextField)component).getText();

		// Return the configured component
		return component;
	}

	// This method is called when editing is completed.
	// It must return the new value to be stored in the cell.
	public Object getCellEditorValue()
	{
		return ((JTextField)component).getText();
	}
}



class Table_Col_4_Editor extends AbstractCellEditor implements TableCellEditor
{
	NextMP3Player parent;

	Table_Col_4_Editor(NextMP3Player p)
	{
		parent = p;
	}
	// This is the component that will handle the editing of the cell value
	JComponent component = new JTextField();

    public boolean isCellEditable(EventObject anEvent) {
        MouseEvent me = (MouseEvent) anEvent;
        try{if (me.getClickCount() == 2) return true;}
		catch (NullPointerException e){/*crops up sometimes but doesn't seem to be a problem*/}
		return false;
    }

	// This method is called when a cell value is edited by the user.
	public Component getTableCellEditorComponent(JTable table, Object value,
			boolean isSelected, int rowIndex, int vColIndex)
	{
		// 'value' is value contained in the cell located at (rowIndex, vColIndex)

		parent.currentRow = rowIndex;

		if (isSelected)
		{
			// cell (and perhaps other cells) are selected
		}

		// Configure the component with the specified value
		((JTextField)component).setText((String)value);

		// Return the configured component
		return component;
	}

	// This method is called when editing is completed.
	// It must return the new value to be stored in the cell.
	public Object getCellEditorValue()
	{
		String newVal = ((JTextField)component).getText();

		parent.previousFileName = (String)parent.table.getModel().getValueAt(parent.currentRow, 0);
		parent.currentFileName = (String)parent.table.getModel().getValueAt(parent.currentRow, 0);
		parent.currentLastPlay = (String)parent.table.getModel().getValueAt(parent.currentRow, 1);
		parent.currentPlays = (String)parent.table.getModel().getValueAt(parent.currentRow, 2);
		parent.currentTags = newVal;
		parent.currentInfo = (String)parent.table.getModel().getValueAt(parent.currentRow, 4);
		parent.updateDatabase();

		return ((JTextField)component).getText();
	}
}



class Table_Col_5_Editor extends AbstractCellEditor implements TableCellEditor
{
	NextMP3Player parent;

	Table_Col_5_Editor(NextMP3Player p)
	{
		parent = p;
	}
	// This is the component that will handle the editing of the cell value
	JComponent component = new JTextField();

    public boolean isCellEditable(EventObject anEvent) {
        MouseEvent me = (MouseEvent) anEvent;
        try{if (me.getClickCount() == 2) return true;}
		catch (NullPointerException e){/*crops up sometimes but doesn't seem to be a problem*/}
		return false;
    }


	// This method is called when a cell value is edited by the user.
	public Component getTableCellEditorComponent(JTable table, Object value,
			boolean isSelected, int rowIndex, int vColIndex)
	{
		// 'value' is value contained in the cell located at (rowIndex, vColIndex)

		parent.currentRow = rowIndex;

		if (isSelected)
		{
			// cell (and perhaps other cells) are selected
		}

		// Configure the component with the specified value
		((JTextField)component).setText((String)value);

		// Return the configured component
		return component;
	}

	// This method is called when editing is completed.
	// It must return the new value to be stored in the cell.
	public Object getCellEditorValue()
	{
		String newVal = ((JTextField)component).getText();

		parent.previousFileName = (String)parent.table.getModel().getValueAt(parent.currentRow, 0);
		parent.currentFileName = (String)parent.table.getModel().getValueAt(parent.currentRow, 0);
		parent.currentLastPlay = (String)parent.table.getModel().getValueAt(parent.currentRow, 1);
		parent.currentPlays = (String)parent.table.getModel().getValueAt(parent.currentRow, 2);
		parent.currentTags = (String)parent.table.getModel().getValueAt(parent.currentRow, 3);
		parent.currentInfo = newVal;
		parent.updateDatabase();

		return ((JTextField)component).getText();
	}
}




class MD5
{
	public static String get(File f)
	{
		MessageDigest digest = null;
		try{
			digest = MessageDigest.getInstance("MD5");}
		catch (java.security.NoSuchAlgorithmException e){System.err.println("Error3: " + e.getMessage());}

		InputStream is = null;
		try{
			is = new FileInputStream(f);}
			catch (java.io.FileNotFoundException e){System.err.println("Error4: " + e.getMessage());}

		byte[] buffer = new byte[8192];
		int read = 0;
		try
		{
			while( (read = is.read(buffer)) > 0) {
				digest.update(buffer, 0, read);
			}
			byte[] md5sum = digest.digest();
			BigInteger bigInt = new BigInteger(1, md5sum);
			String output = bigInt.toString(16);

			return output;
		}
		catch(IOException e)
		{
			throw new RuntimeException("Unable to process file for MD5", e);
		}
		finally
		{
			try {
				is.close();
			}
			catch(IOException e) {
				throw new RuntimeException("Unable to close input stream for MD5 calculation", e);
			}
		}
	}
}
